require 'socket'
require 'structformatter'

module TeamCymru
	class MalwareResult < Struct.new(:hash, :timestamp, :percent_detect)
		def initialize(hash, timestamp, percent_detect)
			self.hash = hash
			self.timestamp = Time.at(timestamp.to_i)
			self.percent_detect = (percent_detect == "NO_DATA") ? 0 : percent_detect.to_i
		end
	end
			
	class Malware
		def initialize(server='hash.cymru.com', port=43)
			@server = server
			@port = port
		end

		def lookup(hashes)
			if hashes.class == Array
				hashes = hashes.join("\n")
			end
			res = []
			t = TCPSocket.new(@server,@port)
			t.write("begin\nverbose\n#{hashes}\nend\n")
			t.each_line do |l|
				next if l =~ /^#/
				res << MalwareResult.new(*(l.chomp.split(/\s+/,3)))
			end
			res
		end
	end
end